import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Future;

public class ExecutorTest3_1 {
    public ExecutorTest3_1() {
        ExecutorService e = Executors.newSingleThreadExecutor();

        Future future = e.submit(new RunnableTask());
        System.out.println("RuunableTask is Called");
        System.out.println("Future#isCancelled(): " + future.isCancelled());
        System.out.println("Future#isDone(): " + future.isDone());

        future.cancel(true);
        System.out.println("Future#isCancelled(): " + future.isCancelled());
        System.out.println("Future#isDone(): " + future.isDone());

        e.shutdown();
    }

    class RunnableTask implements Runnable {
        public void run() {
            try {
                Thread.sleep(5000L);
            } catch (InterruptedException ex) {
                System.out.println("RunnableTask is Canceled");
		ex.printStackTrace();
		return;
            }
            System.out.println("RunnableTask is Done.");
        }
    }

    public static void main(String[] args) {
        new ExecutorTest3_1();
    }
}
