import java.util.concurrent.Callable;
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;

public class ExecutorTest6 {
    public ExecutorTest6() {
        ExecutorService e = Executors.newFixedThreadPool(3);

        System.out.println("Initial Thread Pool:");
        ConcurrentUtils.listThread();
        
        e.execute(new RunnableTask("Task 0"));

        System.out.println("Thread Pool:");
        ConcurrentUtils.listThread();

        e.execute(new RunnableTask("Task 1"));

        try {
            Thread.sleep(3000L);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }

        System.out.println("Processed Threads:");
        ConcurrentUtils.listThread();

        e.shutdown();

        System.out.println("Terminating Threads:");
        ConcurrentUtils.listThread();
    }

    class RunnableTask implements Runnable {
        private String name;

        public RunnableTask(String name) {
            this.name = name;
        }

        public void run() {
            System.out.println(name + " Starts.");

            try {
                Thread.sleep(1000L);
            } catch (InterruptedException ex) {
                System.out.println(name + " is Canceled");
                return;
            }
            System.out.println(name + " is Done.");
        }
    }

    public static void main(String[] args) {
        new ExecutorTest6();
    }
}
